﻿//Directive to implement HEADER
FrameworkApp.directive('headerBar', function($rootScope) {
    return {
        restrict: 'C',
        templateUrl: '../html5/Views/ui/' + $rootScope.selectedLang + '/header.html',
        link: function($scope, $rootScope, elem, attrs) {

        }
    }
});

FrameworkApp.directive("langselectionurl", function() {
    return {
        restrict: 'A',
        templateUrl: "../html5/Views/lang_select.html"
    };
})

// FrameworkApp.directive("intropageurl", function () {
//     return {
//         restrict: 'A',
//         templateUrl: '../html5/Views/ui/en/intro.html'
//     };
// })

//Directive to implement PAGE CONTAINER
FrameworkApp.directive('pageContainer', function($animate, $rootScope) {
    return {
        restrict: 'C',
        templateUrl: $rootScope.deviceUrl + '/container.html',
        link: function($scope, $rootScope, elem, attrs) {

        }
    }
});

//Directive to implement FOOTER
FrameworkApp.directive('footerBar', function($rootScope) {
    return {
        restrict: 'C',
        templateUrl: '../html5/Views/ui/' + $rootScope.selectedLang + '/footer.html',
        link: function($scope, $rootScope, elem, attrs) {

        }
    }
});

//Directive to implement MENU
FrameworkApp.directive('menuContainer', function($rootScope) {
    return {
        restrict: 'C',
        templateUrl: $rootScope.deviceUrl + '/menu.html',
        link: function($scope, $rootScope, elem, attrs) {},
        controller: function($scope) {
            $scope.closeMenu = function() {
                $('.menu-page-list .tree-toggler').parent().children('ul.tree').toggle(200);
                $('.menu').slideToggle(200);
                //$(".resource-btn").css("pointer-events", "all");
                $(".help-btn").css("pointer-events", "all");
                //	$('.resource-btn').css('opacity','1');
                //$('.menu-btn').css('opacity','1');
            }
        }
    }
});

//Directive to implement MENU LIST inside MENU
FrameworkApp.directive('menuList', function() {
    return {
        restrict: 'A',
        scope: {
            isOpen: "=menuList" // 'data-slide-toggle' in our html
        },
        link: function(scope, element, attr) {
            var slideDuration = parseInt(attr.slideToggleDuration, 10) || 200;
            scope.$watch('isOpen', function(newIsOpenVal, oldIsOpenVal) {
                if (newIsOpenVal !== oldIsOpenVal) {
                    element.stop().slideToggle(slideDuration);

                }
                $('.menu-page-list .tree-toggler').parent().children('ul.tree').toggle(200, function() {
                    if ($('.menu').css('display') == 'none') {
                        $(".resource-btn").css("pointer-events", "all");
                        $(".help-btn").css("pointer-events", "all");
                    } else {
                        $(".resource-btn").css("pointer-events", "none");
                        $(".help-btn").css("pointer-events", "none");

                        var currentNode = $(".menu-page-list").find(".current-topic")
                        if (currentNode.attr('data-expand') != "false") {
                            currentNode.find("i").removeClass('fa-arrow-down').addClass('fa-arrow-right');
                            currentNode.next('.tree').slideDown();
                            $('.menu-page-list .tree').not(currentNode.next('.tree')).slideUp();
                        }
                    }

                });


            });
        }
    };
});

//Directive to implement MENU LIST inside MENU
FrameworkApp.directive('cogList', function() {
    return {
        restrict: 'A',
        scope: {
            isOpen: "=cogList" // 'data-slide-toggle' in our html
        },
        link: function(scope, element, attr) {
            var slideDuration = parseInt(attr.slideToggleDuration, 10) || 200;
            scope.$watch('isOpen', function(newIsOpenVal, oldIsOpenVal) {
                if (newIsOpenVal !== oldIsOpenVal) {
                    element.stop().slideToggle(slideDuration);
                }
                $('.cog-item .tree-toggler').parent().children('ul.tree').toggle(200);
            });
        }
    };
});

//Directive to implement MENU
FrameworkApp.directive('cogContainer', function($rootScope) {
    return {
        restrict: 'C',
        templateUrl: $rootScope.deviceUrl + '/cog.html',
        link: function($scope, $rootScope, elem, attrs) {},
        controller: function($scope) {

        }
    }
});

FrameworkApp.directive('introControl', function() {
    return {
        restrict: 'A',
        link: function($scope, $rootScope, elem, attrs) {},
        controller: function($scope, $rootScope, $timeout, $timeout) {
            $scope.page2 = true;
            var vdo = document.getElementById("introVideo");
            vdo.load();
            vdo.play();
            vdo.addEventListener('ended', function() {
                $rootScope.markVisitedPage();
            });

            $scope.GotoNextpage1 = function() {
                $rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage] = "1"
                $scope.gotoNextPage()
            }

        }
    }
});

FrameworkApp.directive('videoCompletion', function() {
    return {
        restrict: 'A',
        link: function($scope, $rootScope, elem, attrs) {},
        controller: function($scope, $rootScope, $timeout, $timeout) {
            $scope.page2 = true;
            var vdo = document.getElementById("introVideo");
            vdo.load();
            if ($rootScope.CourseMenu.module.topics[$rootScope.currentTopic].pages[$rootScope.currentPage].isAuto == "true") {
                vdo.play();
            } else {
                $scope.showPlayBtn = true;
            }
            $scope.playVideo = function(_id) {
                $scope.showSkipVideo = true;
                vdo.play();
                $scope.showPlayBtn = false;
                // $(".audio-btn").addClass("disablePlay");
                /* $(".replayBtn").addClass("disablePlay"); */
            };
            vdo.addEventListener('ended', function() {
                $rootScope.markVisitedPage();
            });

        }
    }
});

// FrameworkApp.directive('audioCompletion', function () {
//     return {
//         restrict: 'A',
//         link: function ($scope, $rootScope, elem, attrs) {
//         },
//         controller: function ($scope, $rootScope, $timeout, $timeout) {
//             var vdo = document.getElementById("course-audio");
//             vdo.load();
//             vdo.play();
//             vdo.addEventListener('ended', function () {
//                 $rootScope.markVisitedPage();
//             });

//         }
//     }
// });
FrameworkApp.directive('animationCompletion', function() {
    return {
        restrict: 'CA',
        link: function($scope, $rootScope, elem, attrs) {

        },
        controller: function($scope, $rootScope, $timeout, $timeout) {
            var animationEndCheck = 'webkitAnimationEnd mozAnimationEnd oAnimationEnd animationend';
            $('.animationCompletion').one(animationEndCheck, function() {
                $rootScope.isNextButtonDisabled = false;
                $rootScope.markVisitedPage();
            })
        }
    }
});
// if($rootScope.CourseContent.static == 'true'){
//     $('.page-nav-btn').removeClass('btnDisabled')
//     $('.mask-right').css('cursor','pointer')
// }


FrameworkApp.directive('bindHtmlCompile', ['$compile', function($compile) {
    return {
        restrict: 'A',
        link: function(scope, element, attrs) {
            scope.$watch(function() {
                return scope.$eval(attrs.bindHtmlCompile);
            }, function(value) {
                // In case value is a TrustedValueHolderType, sometimes it
                // needs to be explicitly called into a string in order to
                // get the HTML string.
                element.html(value && value.toString());
                // If scope is provided use it, otherwise use parent scope
                var compileScope = scope;
                if (attrs.bindHtmlScope) {
                    compileScope = scope.$eval(attrs.bindHtmlScope);
                }
                $compile(element.contents())(compileScope);
            });
        }
    };
}]);

FrameworkApp.directive('courseAssessment', function() {
    return {
        restrict: 'CA',
        link: function($scope, $rootScope, elem, attrs) {},
        controller: function($scope, $rootScope) {
            $rootScope.resumeLastPage = false;
            $rootScope.isPrevButtonDisabled = false;
            //$rootScope.asmntScoreArray = new Array(5);
            $rootScope.assesmentScore = 0;
            $rootScope.startAssessment = function() {
                $rootScope.checkInternet($rootScope.selectedLang);
                if (navigator.onLine) {
                    $rootScope.assesmentStarted = true;
                    $rootScope.isNextButtonDisabled = true;
                    $rootScope.isPrevButtonDisabled = true;
                    $rootScope.assesmentScore = 0;
                    $rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage] = '1';
                    $rootScope.loadScreen($rootScope.currentModule, $rootScope.currentTopic, $rootScope.currentPage + 1);
                }
            }
            $rootScope.assesmentQuestionIndex = [];
            $rootScope.CourseContent.pageHeading = $rootScope.CourseContent.pageHeading;
            console.log($rootScope.pageStatusList)

            if ($rootScope.currentTopic + 1 == $rootScope.CourseConfig.PreAssessmentSection) {
                $rootScope.isPrevButtonDisabled = true;
            }
            $rootScope.isNextButtonDisabled = true;

            $rootScope.createaAssesment();
        }
    }
});


FrameworkApp.directive('courseAssessmentIntro', function() {
    return {
        restrict: 'CA',
        link: function($scope, $rootScope, elem, attrs) {},
        controller: function($scope, $rootScope) {
            $rootScope.isPrevButtonDisabled = false;
            $rootScope.startAssessment = function() {
                $rootScope.checkInternet($rootScope.selectedLang);
                if (navigator.onLine) {
                    $rootScope.isNextButtonDisabled = true;
                    $rootScope.isPrevButtonDisabled = false;
                    $rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage] = '1';
                    $rootScope.loadScreen($rootScope.currentModule, $rootScope.currentTopic, $rootScope.currentPage + 1);
                }
            }
            $rootScope.CourseContent.pageHeading = $rootScope.CourseContent.pageHeading;
            if ($rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage] == 1) {
                $rootScope.isNextButtonDisabled = true;
                $rootScope.markVisitedPage();
            } else {
                $rootScope.isNextButtonDisabled = true;
            }
            $rootScope.createaAssesment();
        }
    }
});


FrameworkApp.directive('courseAssessmentGame', function() {
    return {
        restrict: 'A',
        link: function($scope, $rootScope, elem, attrs) {},
        controller: function($scope, $rootScope, $interval) {
            $rootScope.isNextButtonDisabled = false;
            $rootScope.startAssessment = function() {
                $rootScope.assesmentStarted = true;
                $rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage] = '1'
                $rootScope.loadScreen($rootScope.currentModule, $rootScope.currentTopic, 1);
            }
            $rootScope.blinkQuizWrapper = false;
            $(".menu-contain").css("pointer-events", "all");
            $('.menu-contain').css('opacity', '1');
            $rootScope.isAnswered = false;
            $rootScope.isLastQuestion = false;
            $rootScope.assesmentScore = 0;
            if ($rootScope.CourseConfig.AppType.toLowerCase() == 'scorm1.2') {

            }
            $rootScope.asmntScoreArray = [2, 2, 2, 2, 2, 2, 2, 2, 2, 2];
            if ($rootScope.isPooled) {
                $rootScope.assesmentQuestionIndex = [];
            }

            //$rootScope.timerMins = 0;
            //$rootScope.timerSecs = 0;
            $interval.cancel($rootScope.promiseInterval);
            // $rootScope.markVisitedPage();
            $rootScope.createaAssesment();
            console.log($rootScope.assesmentQuestionIndex)
        }
    }
});




// FrameworkApp.directive('adaptive', ['$rootScope', '$timeout', function($rootScope, $timeout) {
//     return {
//         restrict: 'A',
//         link: function(scope, element, attrs) {
//             var courseW = 1000;
//             var courseH = 650;
//             $rootScope.scaleFactor = 1;

//             var resizer = function() {
//                 var isMobile_1 = /Android|iPhone|BlackBerry/i.test(navigator.userAgent);
//                 if (isMobile_1 == true) {
//                     $("body").css({ 'width': '100%', 'height': '100%' });
//                     $el = $("#body");
//                     $rootScope.scaleFactor = Math.min(
//                         window.innerWidth / courseW,
//                         window.innerHeight / courseH);

//                     cssObj = {
//                         "transform-origin": "top center",
//                         "transform": "scale(" + $rootScope.scaleFactor + ")"

//                     }
//                     $("body").addClass("main-body")
//                     $("body").css({ 'width': '1000px', 'position': 'fixed' });
//                     $("#body").css({ 'height': '650px' });
//                     $("#body").css(cssObj);



//                     $('#viewport').attr('content', 'width=' + $(window).width() / courseW + ', height=' + $(window).height() / courseH + ', initial-scale=1,maximum-scale=1');

//                 } else {
//                     $("body").removeClass("main-body")
//                 }

//             }

//             resizer();
//             $(window).resize(function() {
//                 $timeout(function() {
//                     // debugger
//                     resizer()
//                 }, 100);
//             });
//         }
//     };
// }]);

FrameworkApp.directive('adaptive', ['$rootScope', '$timeout', function ($rootScope, $timeout) {
    return {
        restrict: 'A',
        link: function (scope, element, attrs) {
            var courseW = 1000;
            var courseH = 650;
            $rootScope.scaleFactor = 1;
            var resizer = function(){
                var isMobile_1 = /Android|iPhone|BlackBerry/i.test(navigator.userAgent);
                if (isMobile_1 == true) {
                    $("body").css({'width':'100%', 'height':'100%'});
                    $el = $("#body");
                    $rootScope.scaleFactor = Math.min(
                        window.innerWidth/ courseW,
                        window.innerHeight / courseH);
                    cssObj = {
                        "transform-origin": "top center",
                        "transform":"scale("+$rootScope.scaleFactor+")"
                    }    
                    $("body").addClass("main-body")
                    $("body").css({'width':'1000px','position':'fixed'});
                    $("#body").css({'height':'650px'});
                    $("#body").css(cssObj);
                    $('#viewport').attr('content','width='+$(window).width() / courseW+', height='+ $(window).height() / courseH+', initial-scale=1,maximum-scale=1');
                }else{
                    $("body").removeClass("main-body")
                }
            }
            resizer();
            $(window).resize(function() {
                $timeout(function() {
                    // debugger
                    resizer()
                }, 100);
            });
        }
    };
}]);